=== debian/changelog ===
bear (3.0.8-1) unstable; urgency=medium

  * New upstream release
  * debian/copyright: Bump copyright years

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 05 Feb 2021 22:33:05 +0100

bear (3.0.7-1) unstable; urgency=medium

  * New upstream release
  * debian/control: Add B-D on libsqlite3-dev
  * debian/tests/control: Drop superficial restriction

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 14 Jan 2021 21:57:15 +0100

bear (3.0.6-1) unstable; urgency=medium

  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 02 Jan 2021 09:58:45 +0100

bear (3.0.5-1) unstable; urgency=medium

  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 28 Dec 2020 19:31:47 +0100

bear (3.0.4-1) unstable; urgency=medium

  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 14 Dec 2020 21:52:31 +0100

bear (3.0.3-1) unstable; urgency=medium

  * New upstream release
  * debian/tests: Fix smoke test

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 23 Nov 2020 22:37:28 +0100

bear (3.0.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: Bump Standards-Version
  * debian/: Adapt to new upstream version

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 22 Nov 2020 23:29:03 +0100

bear (2.4.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.

  [ Sebastian Ramacher ]
  * New upstream release
  * debian/control: Bump debhelper compat to 13

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 13 Sep 2020 11:11:12 +0200
