=== debian/tests/control ===
Tests: smoke
Depends: bear, build-essential, python3
Restrictions: allow-stderr
